javax.ejb

## Interface SessionSynchronization

-     public interface SessionSynchronization

  The SessionSynchronization interface allows a stateful session bean instance to be notified by its container of transaction boundaries.

  Only a stateful session bean with container-managed transaction demarcation can receive session synchronization notifications. Other bean types must not implement the SessionSynchronization interface or use the session synchronization annotations.

  A stateful session bean class is not required to implement this interface.

  Since:
    EJB 1.0

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterBegin()` The `afterBegin` method notifies a stateful session bean instance that a new transaction has started, and that the subsequent business methods on the instance will be invoked in the context of the transaction.
    `void` | `afterCompletion(boolean committed)` The `afterCompletion` method notifies a stateful session bean instance that a transaction commit protocol has completed, and tells the instance whether the transaction has been committed or rolled back.
    `void` | `beforeCompletion()` The `beforeCompletion` method notifies a stateful session bean instance that a transaction is about to be committed.

- - ### Method Detail

    - #### afterBegin

          void afterBegin()
                          throws EJBException,
                                 RemoteException

      The `afterBegin` method notifies a stateful session bean instance that a new transaction has started, and that the subsequent business methods on the instance will be invoked in the context of the transaction.

      The instance can use this method, for example, to read data from a database and cache the data in the instance fields.

      This method executes in the proper transaction context.

      Throws:
        `EJBException` - Thrown by the method to indicate a failure caused by a system-level error.
        `RemoteException` - This exception is defined in the method signature to provide backward compatibility for enterprise beans written for the EJB 1.0 specification. Enterprise beans written for the EJB 1.1 and later specifications should throw the javax.ejb.EJBException instead of this exception. Enterprise beans written for the EJB 2.0 and later specifications must not throw the java.rmi.RemoteException.
      See Also:
        `AfterBegin`

    - #### beforeCompletion

          void beforeCompletion()
                                throws EJBException,
                                       RemoteException

      The `beforeCompletion` method notifies a stateful session bean instance that a transaction is about to be committed. The instance can use this method, for example, to write any cached data to a database.

      This method executes in the proper transaction context.

      Note: The instance may still cause the container to rollback the transaction by invoking the `setRollbackOnly` method on the session context, or by throwing an exception.

      Throws:
        `EJBException` - Thrown by the method to indicate a failure caused by a system-level error.
        `RemoteException` - This exception is defined in the method signature to provide backward compatibility for enterprise beans written for the EJB 1.0 specification. Enterprise beans written for the EJB 1.1 and later specification should throw the javax.ejb.EJBException instead of this exception. Enterprise beans written for the EJB 2.0 and later specifications must not throw the java.rmi.RemoteException.
      See Also:
        `BeforeCompletion`

    - #### afterCompletion

          void afterCompletion(boolean committed)
                               throws EJBException,
                                      RemoteException

      The `afterCompletion` method notifies a stateful session bean instance that a transaction commit protocol has completed, and tells the instance whether the transaction has been committed or rolled back.

      This method executes with no transaction context.

      Parameters:
        `committed` - True if the transaction has been committed, false if is has been rolled back.
      Throws:
        `EJBException` - Thrown by the method to indicate a failure caused by a system-level error.
        `RemoteException` - This exception is defined in the method signature to provide backward compatibility for enterprise beans written for the EJB 1.0 specification. Enterprise beans written for the EJB 1.1 and later specification should throw the javax.ejb.EJBException instead of this exception. Enterprise beans written for the EJB 2.0 and later specifications must not throw the java.rmi.RemoteException.
      See Also:
        `AfterCompletion`

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.